---
type: api
title: Get mapping definitions
description: **All methods and paths for this operation:**
url: https://www.elastic.co/elastic/docs-builder/docs/4371/api/doc/elasticsearch/operation/operation-indices-get-mapping
resource: https://www.elastic.co/elastic/docs-builder/docs/4371/api/doc/elasticsearch/operation/operation-indices-get-mapping
products:
  - Elasticsearch
---

# Get mapping definitions


Availability:

## Paths

- `GET` `/{index}/_mapping`
- `GET` `/_mapping`

- [Api key auth](/elastic/docs-builder/docs/4371/api/doc/elasticsearch/authentication#apikeyauth)
- [Basic auth](/elastic/docs-builder/docs/4371/api/doc/elasticsearch/authentication#basicauth)
- [Bearer auth](/elastic/docs-builder/docs/4371/api/doc/elasticsearch/authentication#bearerauth)

#### Path Parameters

- `index` (union IndexName | [] IndexName) — optional, leave it out to use `/_mapping`
  Comma-separated list of data streams, indices, and aliases used to limit the request.
Supports wildcards (`*`).
To target all data streams and indices, omit this parameter or use `*` or `_all`.

## Description

For data streams, the API retrieves mappings for the stream’s backing indices.

## Required authorization

* Index privileges: `view_index_metadata`

## Query String Parameters

- `allow_no_indices` (boolean · default: true)
  A setting that does two separate checks on the index expression.
If `false`, the request returns an error (1) if any wildcard expression
(including `_all` and `*`) resolves to zero matching indices or (2) if the
complete set of resolved indices, aliases or data streams is empty after all
expressions are evaluated. If `true`, index expressions that resolve to no
indices are allowed and the request returns an empty result.
- `expand_wildcards` (string ExpandWildcards · default: open)
  Type of index that wildcard patterns can match.
If the request can target data streams, this argument determines whether wildcard expressions match hidden data streams.
Supports comma-separated values, such as `open,hidden`.

Supported values include:
  - `all`: Match any data stream or index, including hidden ones.
  - `open`: Match open, non-hidden indices. Also matches any non-hidden data stream.
  - `closed`: Match closed, non-hidden indices. Also matches any non-hidden data stream. Data streams cannot be closed.
  - `hidden`: Match hidden data streams and hidden indices. Must be combined with `open`, `closed`, or `both`.
  - `none`: Wildcard expressions are not accepted.
  Values: `all`, `open`, `closed`, `hidden`, `none`
- `ignore_unavailable` (boolean · default: false)
  If `false`, the request returns an error if it targets a concrete (non-wildcarded)
index, alias, or data stream that is missing, closed, or otherwise unavailable.
If `true`, unavailable concrete targets are silently ignored.
- `local` (boolean · default: false) — deprecated
  If `true`, the request retrieves information from the local node only.
- `master_timeout` (string Duration · default: 30s)
  Period to wait for a connection to the master node.
If no response is received before the timeout expires, the request fails and returns an error.

## Response

`application/json`

Type: `map string to IndexMappingRecord`

## Code Examples

#### Console

```console
GET /books/_mapping
```

#### JavaScript

```javascript
const response = await client.indices.getMapping({
  index: "books",
});
```

#### Python

```python
resp = client.indices.get_mapping(
    index="books",
)
```

#### curl

```curl
curl -X GET "$ELASTICSEARCH_URL/books/_mapping" \
  -H "Authorization: ApiKey $ELASTIC_API_KEY"
```

#### Java

```java
client.indices().getMapping(g -> g
    .index("books")
);
```

#### C#

```c#
var response = await client.Indices
    .GetMappingAsync(d1 => d1
        .Indices(new[] { "books" })
    );
```

#### PHP

```php
$resp = $client->indices()->getMapping([
    "index" => "books",
]);
```

#### Ruby

```ruby
response = client.indices.get_mapping(
  index: "books"
)
```

